/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2006 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_TRAYBUTTON_H__30CE3799_C179_4214_AE26_4A1BA09E9105__INCLUDED_)
#define AFX_TRAYBUTTON_H__30CE3799_C179_4214_AE26_4A1BA09E9105__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef NIIF_USER
	#define NIIF_USER       0x00000004
#endif

class TrayButton  
{
	friend class Tray;

public:
	TrayButton(Tray *actualtray, HWND sethOwnerWnd, UINT setuID);
	virtual ~TrayButton();

private:

	Tray *tray;

	// owner window
	HWND hOwnerWnd;
	// id
	UINT uID;
	// callback message ( to send to the owner window )
	UINT uCallbackMessage;
	// tooltip text
	string strTooltip;

	//Ballon InfoTips
	string strTitle;
	string strInfo;
	int iTimeOut;
	DWORD dwInfoFlags;

	int buttonx;
	int buttony;
	int buttonwidth;
	int buttonheight;

	int defaultDelta;
	int defaultSize;

	int hoverDelta;
	int hoverSize;

	int hiddenDelta;
	int hiddenSize;

	bool xTrayHideChecked;
	bool userHidden;
	bool useHover;
	int noDragnDrop;

	int fixedPositionInTray;
	int positionInTray;

	void setButtonLayout( int x, int y, int width, int height );
	void setIcon( HICON sethIcon ); 
	bool setTooltip( string setstrTooltip ); 

	bool HasPoint( int xP, int yP );

	bool Update(NOTIFYICONDATA *pnid, bool &changeActiveTooltip, bool &autoShowInfoTip);

	void onButtonClick(UINT nMessage, WPARAM wParam, LPARAM lParam);	

	void onPaint( HDC destDC, int left, int top, int right, int bottom );

protected:

	HICON hIcon;

};

#endif // !defined(AFX_TRAYBUTTON_H__30CE3799_C179_4214_AE26_4A1BA09E9105__INCLUDED_)
