/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2006 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_TRAYICON_H__45E9BA2E_D08D_417E_8251_885A29E5AE47__INCLUDED_)
#define AFX_TRAYICON_H__45E9BA2E_D08D_417E_8251_885A29E5AE47__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct ICONSETTINGS
{
	int iconSize;

	COLORREF icon_hueColor;
	int icon_hueIntensity;
	int icon_luminanceIntensity;
	int icon_saturationIntensity;

	COLORREF icon_mixColor;
	int icon_mixIntensity;
};

class TrayIcon  
{
public:

	TrayIcon();
	virtual ~TrayIcon();

	void configure(const string &name);
	void apply(HDC hDC, int x, int y, int width, int height, int buttonType, HICON hIcon, bool useAlphaMap);

	int getIconSize() { return defaulticon.iconSize; };
	int getHoverIconSize() { return hovericon.iconSize; };
	int getHiddenIconSize() { return hiddenicon.iconSize; };

private:

	void subconfigure(string type, ICONSETTINGS &workSettings, ICONSETTINGS &defaultSettings);

	ICONSETTINGS defaulticon;
	ICONSETTINGS hovericon;
	ICONSETTINGS hiddenicon;

};

#endif // !defined(AFX_TRAYICON_H__45E9BA2E_D08D_417E_8251_885A29E5AE47__INCLUDED_)
